var GameVideo;
(function(GameVideo) {
	const GAMEID = "video";
	var GameVideo = (function(_super) {
		__extends(GameVideo, _super);

		function GameVideo(params) {
			_super.call(this);
			this.params = params;
		}
		var d = __define,
			c = GameVideo,
			p = c.prototype;
		p.create = function(event) {
			this.video = new egret.Video();
			this.video.x = 0;
			this.video.y = 0;
			this.video.width = this.width;
			this.video.height = this.height;
			this.video.fullscreen = false;
			this.video.load(this.params.url);
			this.addChild(this.video);
			this.video.once(egret.Event.COMPLETE, this.onLoad, this);
			this.video.addEventListener(egret.Event.ENDED, this.onComplete, this);
		}
		p.destroy = function() {
			this.video.removeEventListener(egret.Event.ENDED, this.onComplete, this);
			this.video.removeEventListener(egret.Event.COMPLETE, this.onLoad, this);
			this.video.close();
			this.video=null;
            _super.prototype.destroy.call(this);
		}
		p.onLoad = function(event) {
			this.video.play();
		}
		p.onComplete = function(event) {
			this.dispatchEventWith("game_over", true, {
				evt: "end"
			}, false);
		}
		return GameVideo;
	}(VortexGame.GameKid));
	egret.registerClass(GameVideo, 'GameVideo');
	VortexGame.GameManager.regGame(GAMEID, GameVideo);
})(GameVideo || (GameVideo = {}));
////