//这里我的背包
var UIBag = (function(_super) {
    __extends(UIBag, _super);

    function UIBag(argvs) {
        _super.call(this);
        this.content = argvs.content;
        this.super = argvs.super;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = UIBag,
        p = c.prototype;
    p.onAddToStage = function() {
        this.number = 15; //每页显示个数
        this.rowNumber = isVertical ? 3 : 5;
        this.page = 1; //当前页数
        this.itemsOrder = [];
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.graphics.beginFill(0x000000, 0.90);
        this.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
        this.graphics.endFill();
        this.touchEnabled = true;
        this.visible = false;

        this.container = this.super.getContainer("bag");
        this.container.visible = true;
        this.addChild(this.container);

        //背景
        this.contentBg = new egret.Bitmap();
        this.contentBg.name = "bag_contentBg";
        this.container.addChild(this.contentBg);

        //背包标题
        this.title_bag = new egret.Bitmap();
        this.title_bag.name = "bag_title_bag";
        this.title_bag.touchEnabled = false;
        this.title_bag.visible = true;
        this.container.addChild(this.title_bag);
        //当前选中的单元格
        this.currentGrid = new egret.Bitmap();
        this.currentGrid.name = "bag_itembg_active";
        this.currentGrid.touchEnabled = false;
        this.currentGrid.visible = false;
        this.container.addChild(this.currentGrid);
        //上一页
        this.toLeft = new egret.Bitmap();
        this.toLeft.name = "bag_toLeft";
        this.toLeft.touchEnabled = true;
        this.toLeft.visible = false;
        this.container.addChild(this.toLeft);
        //下一页
        this.toRight = new egret.Bitmap();
        this.toRight.name = "bag_toRight";
        this.toRight.touchEnabled = true;
        this.toRight.visible = false;
        this.container.addChild(this.toRight);
        //单元格
        this.grids = new Array();
        for (var i = 0; i < this.number; i++) {
            this.grids[i] = new egret.Sprite();
            this.grids[i].name = "bag_itembg";
            this.grids[i].tag = i;
            this.grids[i].touchEnabled = true;
            this.grids[i].visible = true;
            this.container.addChild(this.grids[i]);
            var bg = new egret.Bitmap();
            bg.name = "itemBg";
            var nameBg = new egret.Bitmap();
            nameBg.name = "bag_item_name";
            var countBg = new egret.Bitmap();
            countBg.name = "bag_item_number";
            var prop = new egret.Bitmap();
            prop.name = "prop";
            var nameTxt = new egret.TextField();
            nameTxt.name = "nameTxt";
            var countTxt = new egret.TextField();
            countTxt.name = "countTxt";
            this.grids[i].addChild(bg);
            this.grids[i].addChild(prop);
            this.grids[i].addChild(nameBg);
            this.grids[i].addChild(countBg);
            this.grids[i].addChild(nameTxt);
            this.grids[i].addChild(countTxt);
        }

          //返回按钮
        this.backButton = new egret.Bitmap();
        this.backButton.name = "bag_Returnbutton";
        this.backButton.touchEnabled = true;
        this.backButton.visible = true;
        this.addChild(this.backButton);

    };
    p.handleTap = function(event) {
        var name = event.target.name;
        if (this.backButton.name === name) {
            this.super.setBagVisible();
            this.super.HideUIExceptMenu(this.visible);
            this.page = 1;
            this.content.closeMenu();
            return;
        };
        if (event.target.name === this.grids[0].name) {
            this.currentGrid.visible = true;
            this.currentGrid.texture = RES.getRes("itembg_active");
            this.currentGrid.width = event.target.width;
            this.currentGrid.height = event.target.height;
            this.currentGrid.x = event.target.x;
            this.currentGrid.y = event.target.y;
            this.currentGrid.tag = event.target.tag;
        } else if (event.target.name === this.toLeft.name) {
            this.page = this.page - 1 ? this.page - 1 : 1;
            this.showBagImg();
        } else if (event.target.name === this.toRight.name) {
            this.page = Math.ceil(this.itemsOrder.length / this.number) - this.page ? this.page + 1 : this.page;
            this.showBagImg();
        }
        event.stopPropagation();
    };
    p.setSkin = function(skinname, res) {
        this.backButton.texture = RES.getRes(res[this.backButton.name].background);
        this.backButton.x = res[this.backButton.name].x;
        this.backButton.y = res[this.backButton.name].y;
        this.title_bag.texture = RES.getRes(res[this.title_bag.name].background);
        this.title_bag.x = res[this.title_bag.name].x;
        this.title_bag.y = res[this.title_bag.name].y;
        this.toLeft.texture = RES.getRes(res[this.toLeft.name].background);
        this.toLeft.x = res[this.toLeft.name].x;
        this.toLeft.y = res[this.toLeft.name].y;
        this.toRight.texture = RES.getRes(res[this.toRight.name].background);
        this.toRight.x = res[this.toRight.name].x;
        this.toRight.y = res[this.toRight.name].y;

        if (res.hasOwnProperty(this.contentBg.name))
        {
            this.contentBg.texture = RES.getRes(res[this.contentBg.name].background);
            this.contentBg.x = res[this.contentBg.name].x;
            this.contentBg.y = res[this.contentBg.name].y;
        }

        for (var i = 0; i < this.grids.length; i++) {
            this.grids[i].width = res[this.grids[i].name].w;
            this.grids[i].height = res[this.grids[i].name].h;
            this.grids[i].x = parseInt(i % this.rowNumber) * (this.grids[i].width + 25)+res[this.grids[i].name].x;
            this.grids[i].y = parseInt(i / this.rowNumber) * (this.grids[i].width + 25)+res[this.grids[i].name].y;
            var itemBg = this.grids[i].getChildByName("itemBg");
            itemBg.texture = RES.getRes(res[this.grids[i].name].background);
            if (isVertical) 
            {
                itemBg.width = res[this.grids[i].name].w;
                itemBg.height = res[this.grids[i].name].h;  
            }
        
            var nameBg = this.grids[i].getChildByName("bag_item_name");
            nameBg.width = itemBg.width;
            nameBg.height = itemBg.height*0.3; 
            var nameTxt = this.grids[i].getChildByName("nameTxt");
            nameBg.texture = RES.getRes(res[nameBg.name].background);
            nameBg.x = 2;
            nameBg.y = this.grids[i].height - 2 - nameBg.height;
            nameTxt.x = nameBg.x;
            nameTxt.y = nameBg.y;
            nameTxt.textAlign = 'center';
            nameTxt.verticalAlign = 'middle';
            nameTxt.width = nameBg.width;
            nameTxt.height = nameBg.height;
            nameTxt.size = parseInt(nameTxt.height / 2);
            var countBg = this.grids[i].getChildByName("bag_item_number");
            countBg.width = itemBg.width;
            countBg.height = nameBg.height;
            var countTxt = this.grids[i].getChildByName("countTxt");
            countBg.texture = RES.getRes(res[countBg.name].background);
            countBg.x = 2;
            countBg.y = 2;
            countTxt.x = countBg.x;
            countTxt.y = countBg.y;
            countTxt.textAlign = 'center';
            countTxt.verticalAlign = 'middle';
            countTxt.width = countBg.width/3;
            countTxt.height = countBg.height;
            countTxt.size = parseInt(countTxt.height / 2);
            var prop = this.grids[i].getChildByName("prop");
            prop.x = 5;
            prop.y = 5;
            prop.width = itemBg.width-10;
            prop.height = itemBg.height-10;
            itemBg.touchEnabled = true;
            this.iconAddMouseOverEventWithTarget(itemBg);
            this.iconAddMouseOutEventWithTarget(itemBg);

            this.iconAddMouseOverEventWithTarget(this.backButton);
            this.iconAddMouseOutEventWithTarget(this.backButton);

        }

        var backBtnPs = ["## $sw - "+this.backButton.x,this.backButton.y,null,null,"## $w",0];
        this.super.positonParameters(this.backButton,backBtnPs);

        this.totalRes = res;

    };
    //设置当前页面显示隐藏
    p.setVisible = function(tag) {
        if (tag) this.showBagImg();
        this.visible = tag;
    };
    p.getVisible = function() {
        return this.visible;
    };
    p.setBag = function(list) {
        this.items = list;
    };
    //设置背包图片
    p.showBagImg = function() {
        this.toLeft.visible = false;
        this.toRight.visible = false;
        for (var i in this.items) {
            this.items[i].value = this.content.vt.gvars[this.items[i].nid] ? this.content.vt.gvars[this.items[i].nid] : 0;
            if (this.items[i].value) {
                if (this.itemsOrder.indexOf(this.items[i].idid) < 0) {
                    this.itemsOrder.push(this.items[i].idid);
                }
            }
        }
        if ((this.itemsOrder.length - (this.page - 1) * this.number) > this.number) {
            this.toRight.visible = true;
        }
        if (this.page > 1) {
            this.toLeft.visible = true;
        }
        for (var i in this.grids) {
            var j = (this.page - 1) * this.number + parseInt(i);
            var prop = this.grids[i].getChildByName("prop");
            var nameTxt = this.grids[i].getChildByName("nameTxt");
            var countTxt = this.grids[i].getChildByName("countTxt");
            var nameBg = this.grids[i].getChildByName("bag_item_name");
            var countBg = this.grids[i].getChildByName("bag_item_number");
            prop.texture = null;
            nameTxt.text = null;
            countTxt.text = null;
            if (this.itemsOrder[j]) {
                var obj = this.getItems(this.itemsOrder[j]);
                if (obj) {
                    prop.texture = RES.getRes(obj.key);
                    nameTxt.text = obj.name;
                    countTxt.text = obj.value;
                }
            }else{
                nameBg.visible = false;
                countBg.visible = false;
            }
        }
    };
    //根据id获取背包内容
    p.getItems = function(idid) {
        for (var i in this.items) {
            if (this.items[i].idid == idid) {
                return this.items[i];
            }
        }
    };

    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        if (name != this.backButton.name) 
        {
            name = "bag_itembg";
        }

        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        if (name != this.backButton.name) 
        {
            name = "bag_itembg";
        }
        event.target.texture = RES.getRes(res[name].background);
    };

    return UIBag;
}(egret.Sprite));
egret.registerClass(UIBag, 'UIBag');