//这里实现菜单功能..
//ly
var Menu = (function(_super) {
    __extends(Menu, _super);

    function Menu(argvs) {
        _super.call(this);
        this.content = argvs.content;
        this.super = argvs.super;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = Menu,
        p = c.prototype;
    p.onAddToStage = function(event) {
        var argvs = {
            content: this.content,
            super: this
        }
        this.width = this.super.width;
        this.height = this.super.height;
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.touchEnabled = true;
        //启用舞台的鼠标支持
        // mouse.enable(this.stage);
        (_typeBox != 'box')?mouse.enable(this.stage):1;
        //防止点击事件穿透
        this.graphics.beginFill(0x000000, 0.9);
        this.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
        this.graphics.endFill();
        this.container = this.super.getContainer("menu_list");
        this.container.visible = true;
        this.addChild(this.container);
        this.menuItmeArray = new Array();
        //背景
        this.contentBg = this.addMenuItem("menu_contentBg");
        this.container.addChild(this.contentBg);
        this.menuItmeArray.push(this.contentBg);
        //菜单数组
        this.menuNameArray = ["menu_temporary", "menu_forever", "menu_review", "menu_setting", "menu_share", "menu_exit", "menu_about"];
        //菜单按钮
        for (var i = 0; i < this.menuNameArray.length; i++) {
            var name = this.menuNameArray[i];
            var item = this.addMenuItem(name);
            this.container.addChild(item);
            this.menuItmeArray.push(item);
        }
        //临时存储
        this.temporary = new Temporary(argvs);
        this.temporary.name = "temporary";
        this.temporary.visible = false;
        this.addChild(this.temporary);
        //永久存储
        this.forever = new Forever(argvs);
        this.forever.name = "forever";
        this.forever.visible = false;
        this.addChild(this.forever);
        //剧情回放
        this.storyReview = new StoryReview(argvs);
        this.storyReview.name = "review";
        this.storyReview.visible = false;
        this.addChild(this.storyReview);
        //设置
        this.menuSet = new MenuSetting(argvs);
        this.menuSet.name = "setting";
        this.menuSet.visible = false;
        this.addChild(this.menuSet);
        //分享
        this.share = new UIShare(argvs);
        this.share.name = "share";
        this.share.visible = false;
        this.addChild(this.share);
        //返回按钮
        this.backBtn = this.addMenuItem("menu_back");
        this.addChild(this.backBtn);
        this.menuItmeArray.push(this.backBtn);
    }
    p.setSkin = function(skinname, res) {
        for (var i = 0; i < this.menuItmeArray.length; i++) {
            var item = this.menuItmeArray[i];
            if (!res.hasOwnProperty(item.name)) {
                continue;
            }
            var textureName = res[item.name].background;
            item.texture = RES.getRes(textureName);
            item.x = res[item.name].x;
            item.y = res[item.name].y;
            this.iconAddMouseOverEventWithTarget(item);
            this.iconAddMouseOutEventWithTarget(item);
            // mouse.setButtonMode(item, true);
            (_typeBox != 'box')?mouse.setButtonMode(item, true):1;
            if (_typeBox == 'box' && item.name == this.menuNameArray[6]) {
                item.visible = false;
            }
        }
        var backBtnPs = ["## $sw - " + this.backBtn.x, this.backBtn.y, null, null, "## $w", 0];
        this.super.positonParameters(this.backBtn, backBtnPs);
        this.setChannel(true);
        this.temporary.setSkin(skinname, res);
        this.forever.setSkin(skinname, res);
        this.storyReview.setSkin(skinname, res);
        this.share.setSkin(skinname, res);
        this.menuSet.setSkin(skinname, res);
        this.totalRes = res;
    }
    p.addMenuItem = function(name) {
        var item = new egret.Bitmap();
        item.touchEnabled = true;
        item.name = name;
        return item;
    }
    p.handleTap = function(event) {
        var self = this;
        if (event.target.name == this.backBtn.name) {
            //返回
            this.content.closeMenu();
            this.visible = false;
            this.super.HideUIExceptMenu(this.visible);
        } else if (event.target.name == this.menuNameArray[0]) {
            //临时存储
            this.temporarySave();
        } else if (event.target.name == this.menuNameArray[1]) {
            //永久存储
            this.foreverSave();
        } else if (event.target.name == this.menuNameArray[2]) {
            //剧情回放
            this.storyReview.visible = true;
            this.storyReview.setReviewText();
            this.AllMeunItemShowOrHide(false);
        } else if (event.target.name == this.menuNameArray[3]) {
            //设置
            this.menuSet.visible = true;
            this.AllMeunItemShowOrHide(false);
        } else if (event.target.name == this.menuNameArray[4]) {
            //分享
            if (_typeBox == 'preview') {
                //预览不给分享
                return;
            }
            if (this.super.boxShare()) {
                return;
            };
            this.share.visible = true;
            this.AllMeunItemShowOrHide(false);
        } else if (event.target.name == this.menuNameArray[5]) {
            //退出
            if (this.super.boxExit()) {
                return;
            };
            // window.close();
            // window.location.href = Config.official;
            // this.AllMeunItemShowOrHide(false);
            // this.visible = false;
            // this.super.HideUIExceptMenu(this.visible);
        } else if (event.target.name == this.menuNameArray[6]) {
            //关于漩涡
            if (_typeBox == 'preview') {
                return;
            };
            window.open(Config.official);
        }
        event.stopPropagation();
    };
    //true:表示菜单选项显示 
    //false:表示隐藏菜单选项
    p.AllMeunItemShowOrHide = function(flag) {
        this.backBtn.visible = flag;
        for (var i = 0; i < this.menuItmeArray.length; i++) {
            var item = this.menuItmeArray[i];
            item.visible = flag;
        }
        this.setChannel(flag);
    }
    p.setChannel = function(flag) {
        if (flag) {
            if (_typeBox == "box") {
                this.container.getChildByName("menu_about").visible = false;
                this.container.getChildByName("menu_exit").visible = true;
            } else {
                this.container.getChildByName("menu_about").visible = true;
                this.container.getChildByName("menu_exit").visible = false;
            };
        };
    }
    p.showOneMenuItem = function(target) {
        //退出
        this.visible = true;
        target.visible = true;
        this.AllMeunItemShowOrHide(false);
    }
    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background);
    };
    p.foreverSave = function() {
        var self = this;
        this.content.read({
            type: 2
        }, function(data) {
            if (typeof data != 'undefined' && typeof data.msg != 'undefined') {
                self.forever.render(data.msg);
            };
            self.forever.visible = true;
            self.AllMeunItemShowOrHide(false);
        });
    };
    p.temporarySave = function() {
        var self = this;
        this.content.read({
            type: 1
        }, function(data) {
            if (typeof data != 'undefined' && typeof data.msg != 'undefined') {
                self.temporary.render(data.msg);
            };
            self.temporary.visible = true;
            self.AllMeunItemShowOrHide(false);
        });
    };
    return Menu;
}(egret.Sprite));
egret.registerClass(Menu, 'Menu');
////