//临时存储
// ly
var Temporary = (function(_super) {
    __extends(Temporary, _super);

    function Temporary(argvs) {
        _super.call(this);
        this.content = argvs.content;
        this.super = argvs.super;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = Temporary,
        p = c.prototype;
    p.onAddToStage = function() {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.touchEnabled = true;
        this.width = this.super.width;
        this.height = this.super.height;

        this.graphics.beginFill(0x000000, 0.001);
        this.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
        this.graphics.endFill();

        this.container = this.super.super.getContainer("tp");
        this.container.visible = true;
        this.addChild(this.container);

        this.itemBgArray = new Array();
        //背景
        this.contentBg = this.addBitmapItem("temporary_contentBg");
        this.container.addChild(this.contentBg);
        this.itemBgArray.push(this.contentBg);
        //标题
        this.titlebg = this.addBitmapItem("temporary_title");
        this.container.addChild(this.titlebg);
        this.itemBgArray.push(this.titlebg);
        //6个按钮
        this.temporaryArray = new Array();
        //6个标题
        this.itemTitleArray = new Array();
        //6个内容
        this.itemContentArray = new Array();
        //6个临时存储
        var itemNameArray = ["temporary_One", "temporary_Two", "temporary_Three", "temporary_Four", "temporary_Five", "temporary_Six"];
        var txName = "temporary_label";
        for (var i = 0; i < 6; i++) {
            var itemName = itemNameArray[i];
            var itemBg = this.addBitmapItem(itemName);
            itemBg.tag = i;
            this.container.addChild(itemBg);
            this.temporaryArray.push(itemBg);
            var txItem = this.addTimeItem();
            txItem.name = txName;
            this.container.addChild(txItem);
            this.itemTitleArray.push(txItem);
            var itemContent = this.addBitmapItem("");
            itemContent.tag = i + 100;
            this.container.addChild(itemContent);
            this.itemContentArray.push(itemContent);
        }
        //返回按钮
        this.backBtn = this.addBitmapItem("temporary_back");
        this.addChild(this.backBtn);
        this.itemBgArray.push(this.backBtn);
        this.currentPage = 1;
    }
    p.clear = function() {
        //还原成初始化的状态
        for (var i = 0; i < this.temporaryArray.length; i++) {
            var tItem = this.temporaryArray[i];
            tItem.visible = true;
            tItem.texture = RES.getRes(this.totalRes[tItem.name].background);
            var txItem = this.itemTitleArray[i];
            txItem.text = "";

            var cItem = this.itemContentArray[i];
            cItem.texture = null;
            cItem.visible = false;
        }
    }
    p.render = function(data) {
        this.clear();
        var self = this;
        var render_arr = {};
        console.log(data.result);

        for (var i = 0; i < this.temporaryArray.length; i++) {
            var saveDocumentData = data.result[i];
            var tItem = this.temporaryArray[i];
            var cItem = this.itemContentArray[i];
            cItem.texture = null;
            if (saveDocumentData) {
                cItem.visible = true;
                // tItem.texture = RES.getRes(res[tItem.name].background);
                var imgid = "savePic/" + this.content.vt.script.gameId + "/" + saveDocumentData.sceneId + ".png&" + new Date().getTime();
                cItem.saveDocumentData = saveDocumentData;
                render_arr[imgid] = cItem;
                this.content.net.getImgFs(imgid, function(texture,key) {
                    var ccItem = render_arr[key];
                    ccItem.texture = texture;
                });
                var txItem = this.itemTitleArray[i];
                txItem.text = saveDocumentData.SCENE.datetime;
            }
        }
    }
    p.setSkin = function(skinname, res) {
        for (var i = 0; i < this.itemBgArray.length; i++) {
            var item = this.itemBgArray[i];
            item.texture = RES.getRes(res[item.name].background);
            item.x = res[item.name].x;
            item.y = res[item.name].y;
        }
        
        var backBtnPs = ["## $sw - "+this.backBtn.x,this.backBtn.y,null,null,"## $w",0];
        this.super.super.positonParameters(this.backBtn,backBtnPs);

        var txName = this.itemTitleArray[0].name;
        //这个参数判断时间显示在图片里面还是图片外。(eg.水墨是显示在图片里,默认显示在图片外)
        // 取值 1 or -1；
        var txIsOut = 1;
        if (res[txName].hasOwnProperty("isOut")) {
            txIsOut = res[txName].isOut;
        }
        var marginToPic = 20;
        if (res[txName].hasOwnProperty("marginToPic")) {
            marginToPic = res[txName].marginToPic;
        }
        var txRelativeY = marginToPic * txIsOut;

        var cName = "temporary_itemContent";
        var toTop = 0;
        var toLeft = 0;
        var toBottom = 0;
        var toRight = 0;

        if (res.hasOwnProperty(cName)) 
        {
            toTop = res[cName].toTop;
            toLeft = res[cName].toLeft;
            toBottom = res[cName].toBottom;
            toRight = res[cName].toRight;
        }
        
        for (var i = 0; i < this.temporaryArray.length; i++) {
            var tItem = this.temporaryArray[i];
            tItem.x = res[tItem.name].x;
            tItem.y = res[tItem.name].y;
            tItem.texture = RES.getRes(res[tItem.name].background);
            var txItem = this.itemTitleArray[i];
            txItem.x = tItem.x;
            txItem.y = txRelativeY + tItem.y + tItem.height;
            txItem.width = tItem.width;
            txItem.size = res[txName].fontSize;
            txItem.textColor = res["mainui"].color;
            txItem.fontFamily = res["mainui"].fontFamily;

            var cItem = this.itemContentArray[i];
            cItem.x = tItem.x+toLeft;
            cItem.y = tItem.y+toTop;
            cItem.width = tItem.width - toLeft - toRight;
            cItem.height = tItem.height - toTop - toBottom;
        }
        this.totalRes = res;

        (_typeBox != 'box')?mouse.setButtonMode(this.backBtn,true):1;
        this.iconAddMouseOverEventWithTarget(this.backBtn);
        this.iconAddMouseOutEventWithTarget(this.backBtn);
    }
    p.handleTap = function(event) {
        event.stopPropagation();
        var name = event.target.name;
        if (name == this.titlebg.name) {
            return;
        } else if (name == this.backBtn.name) {
            this.visible = false;
            this.super.AllMeunItemShowOrHide(true);
        }
        if (event.target.saveDocumentData) {
            this.content.closeMenu();
            this.content.load(event.target.saveDocumentData);
            this.visible = false;
            this.super.AllMeunItemShowOrHide(true);
            this.super.visible = false;
            this.super.super.HideUIExceptMenu(this.visible);
        };
    }
    p.itemAnchor = function(item, lx, ly) {
        // item.anchorOffsetX = 0;
        // item.anchorOffsetY = 0;
    }
    p.addBitmapItem = function(name) {
        var item = new egret.Bitmap();
        item.touchEnabled = true;
        item.name = name;
        return item;
    };
    //临时存储的时间文本
    p.addTimeItem = function(o) {
        var txItem = new egret.TextField;
        txItem.textAlign = egret.HorizontalAlign.CENTER;
        txItem.verticalAlign = egret.VerticalAlign.MIDDLE;
        txItem.type = egret.TextFieldType.DYNAMIC;
        return txItem;
    }

    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }

        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }

        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background);
    };

    return Temporary;
}(egret.Sprite));
egret.registerClass(Temporary, 'Temporary');