var vortex;
(function(vortex) {
    function __extends(d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p)) d[p] = b[p];

        function __() {
            this.constructor = d;
        }
        __.prototype = b.prototype;
        d.prototype = new __();
    }
    vortex.extends = __extends;
    var __define = this.__define || function(o, p, g, s) {
        Object.defineProperty(o, p, {
            configurable: true,
            enumerable: true,
            get: g,
            set: s
        });
    };
    vortex.define = __define;
})(vortex || (vortex = {}));
var vortex;
(function(vortex) {
    //把表达式部分剥离出来.这样所有地方都可以用了.
    var isArray = function(v) {
        return toString.apply(v) === '[object Array]';
    }
    var exp = (function() {
        function exp() {
            this.fun = [];
        }
        exp.FUN = [];
        exp.regFun = function(name, fun, thisObj) {
            exp.FUN[name] = {
                thisObj: thisObj,
                fun: fun
            };
        }
        var random = function(min, max) {
            if (max > min) {
                return Math.floor(Math.random() * (max - min)) + min;
            }
            if (min > 0) {
                return Math.floor(Math.random() * min);
            }
            return Math.random();
        }
        exp.regFun("suiji", random, null);
        var d = vortex.define,
            c = exp,
            p = c.prototype;
        p.regFun = function(name, fun, thisObj) {
            this.fun[name] = {
                thisObj: thisObj,
                fun: fun,
            }
        }
        p.getVar = function(name, argvs) {
            if (!argvs) {
                console.log("var not found when get");
                return null;
            }
            var names = name.split(".");
            if (typeof argvs[names[0]] != "undefined") {
                var v = argvs[names[0]];
                for (var i = 1; i < names.length; i++) {
                    if (isArray(v)) names[i] = names[i] * 1;
                    v = v[names[i]];
                    if (!v) return null;
                }
                return v;
            } else {
                return this.getVar(name, argvs.__up__);
            }
        }
        p.setVar = function(name, argvs, value) {
            if (!argvs) {
                console.log("var not found when set")
                return null;
            }
            name += "";
            var names = name.split(".");
            if (typeof argvs[names[0]] != "undefined") {
                var v = argvs;
                for (var i = 0; i < names.length; i++) {
                    if (i == names.length - 1) {
                        if (isArray(v)) names[i] = names[i] * 1;
                        v[names[i]] = value;
                        break;
                    }
                    v = v[names[i]];
                }
                return value;
            } else {
                return this.setVar(name, argvs.__up__, value);
            }
        }
        p.expression = function(input, argvs) {
            var self = this;
            if (!(typeof input === "string")) return input;
            if (input.substr(0, 11) === "expression ") {
                input = input.substr(11);
            } else {
                if (input.substr(0, 3) === "## ") {
                    input = input.substr(3);
                } else {
                    return input;
                }
            }
            var list = input.split(" ");
            var idx = 0;
            var next_token = function() {
                return list[idx++];
            }
            var parseValue = function(v) {
                if (v === "{}") return {};
                if (v === "(") return exe();
                if (v === "[") {
                    v = [];
                    while (list[idx - 1] && list[idx - 1] !== "]") {
                        v.push(exe());
                    }
                    return v;
                }
                if (v === "PI") return Math.PI;
                if (v === "random") return Math.random();
                if (v === "round") return Math.round(parseValue(next_token()));
                if (v === "floor") return Math.floor(parseValue(next_token()));
                if (v === "ceil") return Math.ceil(parseValue(next_token()));
                var n = Number(v);
                if (!isNaN(n)) return n;
                if (v.substr(0, 1) === "$") {
                    return parseValue(self.getVar(v.substr(1), argvs));
                }
                if (self.fun[v] || exp.FUN[v]) {
                    var f = self.fun[v] ? self.fun[v] : exp.FUN[v];
                    var arg = parseValue(next_token());
                    if (!isArray(arg)) arg = [arg];
                    return f.fun.apply(f.thisObj, arg);
                }
                return v;
            }
            var exe = function() {
                var v = null,
                    temp;
                var t;
                while (t = next_token()) {
                    if (t === "=") {
                        var x = v;
                        v = parseValue(next_token());
                        // self.setVar(x, argvs, v);
                        continue;
                    }
                    if (t === "def") {
                        var key = parseValue(next_token());
                        v = parseValue(next_token());
                        argvs[key] = v;
                        continue;
                    }
                    if (t === "+") {
                        v = v + parseValue(next_token());
                        continue;
                    }
                    if (t === "-") {
                        v = v - parseValue(next_token());
                        continue;
                    }
                    if (t === "*") {
                        v = v * parseValue(next_token());
                        continue;
                    }
                    if (t === "%") {
                        v = v % parseValue(next_token());
                        continue;
                    }
                    if (t === "/") {
                        var x = parseValue(next_token());
                        if (x != 0) v = v / x;
                        continue;
                    }
                    if (t === ">") {
                        v = (v > parseValue(next_token()));
                        continue;
                    }
                    if (t === ">=") {
                        v = (v >= parseValue(next_token()));
                        continue;
                    }
                    if (t === "<") {
                        v = (v < parseValue(next_token()));
                        continue;
                    }
                    if (t === "<=") {
                        v = (v <= parseValue(next_token()));
                        continue;
                    }
                    if (t === "==") {
                        v = (v == parseValue(next_token()));
                        continue;
                    }
                    if (t === "..") {
                        v = v + "" + parseValue(next_token());
                        continue;
                    }
                    if (t === "&&") {
                        temp = parseValue(next_token());
                        v = v && temp;
                        continue;
                    }
                    if (t === "||") {
                        temp = parseValue(next_token());
                        v = v || temp;
                        continue;
                    }
                    if (t === "!") {
                        v = !parseValue(next_token());
                        continue;
                    }
                    if (t === "" || t === ";") {
                        continue;
                    }
                    if (t === ")" || t === "," || t === "]") {
                        break;
                    }
                    v = parseValue(t);
                }
                return v;
            }
            return exe();
        }
        return exp;
    })();
    vortex.exp = exp;
})(vortex || (vortex = {}));
var vortex;
(function(vortex) {
    var vm = (function() {
        function vm(argvs) {
            this.exp = new vortex.exp;
            this.argvs = argvs;
            this.script = argvs.script;
            this.content = argvs.content;
            this.startid = this.script.start;
            this.gameid = this.script.gameId;
            this.list = this.script.list;
            // this.build = vortex.build.find("img");
            // this.build.globalBuild(this.script);
            this.cache = new vortex.cache(this);
            this.curid = null;
            this.animating = false;
            this.stopNext = false;
            this.tapNext = false;
            this.vars = {};
            this.gvars = {};
            this.events = {};
            if (_typeBox != 'box') 
            {
               document.title = this.script.global.name;  
            }
        }
        vm.CMD = [];
        vm.regCmd = function(name, fun) {
            vm.CMD[name] = fun;
        }
        var d = vortex.define,
            c = vm,
            p = c.prototype;
        p.doCmd = function(cmd, argvs) {
                if (typeof cmd === "string") cmd = cmd.split(";");
                var result;
                if (vm.CMD[cmd[0]]) result = vm.CMD[cmd[0]].call(this, cmd, argvs);
                return result;
            }
            // p.doCmdList = function(cmds, argvs){
            //     var 
            // }
        p.doCmds = function(cmds, argvs) {
            argvs = argvs ? argvs : this.vars;
            argvs.__up__ ? 0 : argvs.__up__ = this.vars;
            for (var c in cmds) {
                var cmd = cmds[c];
                if (cmd[0] == 'goto') {
                    this.filterArrStop = true;//标记执行了goto，其他组的事件也不执行
                };
                if (cmd === "break") break;
                var ret = this.doCmd(cmd, argvs);
                if (ret === "break") return ret;
            }
        }
        p.resetGvars = function(vars) {
            if (typeof vars != "undefined" && vars != null) {
                this.gvars = vars;
            }
        }
        p.startGame = function(frmId, tag) {
            if (this.script.cmds && this.script.cmds.length > 0) this.doCmds(this.script.cmds);
            if (frmId) {
                var vars = this.cache.getVars(this.script.gameId, this.content.userid);
                if (vars != null && typeof vars != "undefined") {
                    this.resetGvars(vars);
                }
                this.doCmd(["goto", frmId]);
            } else {
                if (solaid && solaid != "all" && !tag) {
                    this.doCmd(["goto", solaid]);
                } else {
                    this.doCmd(["goto", this.startid]);
                }
            }
        }
        p.play = function(frmId, tag) {
            //TODO 做游戏整体初始化.
            //TODO 加载进度.
            //TODO 进入游戏事件触发.待定,记录加载写了以后这里不一定..
            var that = this;
            if (this.script.resa && this.script.resa.length > 0) {
                this.content.vortexResource("iconRes", this.script.resa, function() {
                    that.startGame(frmId, tag);
                })
            } else {
                this.startGame(frmId, tag);
            }
        }
        p.getNumberIdByNumberName = function(numberName) {
            var result = false;
            for (var i in this.script.numList) {
                if (this.script.numList[i].name == numberName) {
                    return this.script.numList[i].n_id;
                }
            }
            return result;
        }
        p.showVariate = function(text) {
            if (typeof text == "undefined" || text == null) return text;
            var result = text;
            var pattern = new RegExp("\\[(.| )+?\\]", "igm");
            var arr = result.match(pattern);
            if (arr != null) {
                for (var key in arr) {
                    var oldStr = arr[key];
                    var temp = oldStr.substring(1, oldStr.length - 1);
                    var order = temp.split(":")[0].toLowerCase();
                    var numberName = temp.split(":")[1];
                    //如果是货币的处理
                    //.........
                    var numberId = this.getNumberIdByNumberName(numberName);
                    if (!numberId) continue;
                    var numberValue = this.exp.getVar(numberId, this.gvars);
                    switch (order) {
                        case "v":
                            //显示当前剧情页的该数值的总值
                            result = result.replace(oldStr, numberValue);
                            break;
                        case "c":
                            var change = this.exp.getVar("c_" + numberId, this.vars);
                            if (change == null || typeof change == "undefined") {
                                change = "0";
                            } else if (change > 0) {
                                change = "+" + change;
                            } else if (change <= 0) {
                                change = change + "";
                            }
                            result = result.replace(oldStr, change);
                            break;
                    }
                }
            } else {
                result = text;
            }
            return result;
        }
        p.showFrame = function(nxtid) {
            if (this.stopNext) return;
            if (!nxtid) return;
            if (nxtid == this.curid) return;
            if (this.content.autoPause) return
            var frmdata = this.getFrm(nxtid);
            if (!frmdata) {
                console.log("frame data not found");
                return;
            }
            if (this.curid) { //避免在时间中发生跳转还继续运行本帧内容.
                this.curid = null; //清除curid,这样就保证frame.leave事件只触发一次.重入本函数时不会再次触发.
                this.trigerEvent("frame.leave");
                if (null != this.curid) return; //事件内执行了goto语句,导致curid变化了.就不再继续执行这里的下一帧内容.
            }
            this.content.dispatchEventWith("nextIconHide", true, null, false);
            this.content.ui.selectStart.visible = false;
            this.content.loadingView.hide();
            this.clrEvent();
            this.clrVars();
            this.curid = nxtid;
            this.cache.setVars(this.script.gameId, this.gvars, this.content.userid);
            this.cache.setFrmId(this.script.gameId, nxtid, this.content.reviewIds, this.content.userid);
            this.doCmds(frmdata.cmds);
            this.content.addReviewIds(nxtid);
            this.content.addReviewText(" ");
            this.trigerEvent("frame.enter"); //这时候事件都已经挂上,出发事件才有意义.
            this.waitAnimateEnd();
        };
        // 获取时间
        p.date = function(format) {
                var DATE = new Date();
                var o = {
                    "M+": DATE.getMonth() + 1, //月份
                    "d+": DATE.getDate(), //日
                    "h+": DATE.getHours(), //小时
                    "m+": DATE.getMinutes(), //分
                    "s+": DATE.getSeconds(), //秒
                    "q+": Math.floor((DATE.getMonth() + 3) / 3), //季度
                    "S": DATE.getMilliseconds() //毫秒
                };
                if (/(y+)/.test(format)) format = format.replace(RegExp.$1, (DATE.getFullYear() + "").substr(4 - RegExp.$1.length));
                for (var k in o)
                    if (new RegExp("(" + k + ")").test(format)) format = format.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
                return format;
            }
            /**
             * 保存存档
             * @param  {[type]} type 1-临时存档 2-永久存档
             */
        p.save = function(type) {
            var params = {
                type: type,
                gameid: this.script.gameId
            };
            params['userid'] = this.content.userid;
            params['data'] = {
                "NUMBER": {
                    "snapshot_before": this.cache.getVars(this.script.gameId, this.content.userid)
                },
                "review": this.cache.getFrmId(this.script.gameId, this.content.userid)[1],
                "sceneId": this.curid,
                "SCENE": {
                    "datetime": this.date('yyyy-MM-dd hh:mm:ss')
                }
            };
            var self = this;
            this.content.save(params, function(e) {
                if (type == 2) {
                    var msg = "已解锁该存储点";
                    var params = {
                        width: 300,
                        height: 60,
                        y: self.content.height / 2 + self.content.y + 10,
                    }
                    self.content.vortexMsg(msg, params);
                }
            });
        }
        p.getFrm = function(frmid) {
            var frmdata = this.list[frmid];
            if (!frmdata) return null;
            frmdata["frmid"] = frmid;
            // if (!frmdata.cmds) {
            //     var d = this.build.frameBuild(frmdata, this.script.tool_box);
            //     frmdata.cmds = d[0];
            //     frmdata.resa = d[1];
            // }
            
            //遍历avatar 把 act层中的avatar资源放入预加载中
            for (var key in frmdata['cmds']) 
            {
                if (frmdata['cmds'][key]&&frmdata['cmds'][key][0]) 
                {
                    if (frmdata['cmds'][key][0] == 'avatar') 
                    {
                        var name = frmdata['cmds'][key][1];
                        var id = frmdata['cmds'][key][2];
                        var atData = this.content.vt.script.avatars[id];

                        for (var i in atData) {
                            var resid = atData[i];
                            if (!resid) { continue;}
                            frmdata.resa.push({
                                name: resid,
                                type: "image",
                                url: resid
                            });
                        }

                    }
                }
            } 

            return frmdata;
        }
        p.preLoad = function(frmdata) {
            var nf = frmdata;
            for (var i = 0; i < 5; i++) { //目前预加载5帧
                if (!nf.next) break;
                var id = nf.next;
                var nf = this.getFrm(nf.next);
                if (nf) {
                    this.content.vortexResource(id, nf.resa);
                }
            }
        }
        p.getToolsInToolBox = function() {
            var toolBox = this.script.tool_box;
            var tool;
            var tools = [];
            var toolInfo = null;
            var layerEvent;
            var cmds = [];
            if (!toolBox) return tools;
            tools.push({
                id: "hand",
                resid: toolBox.handBg,
                cmds: [
                    ["delToolVars", null, null]
                ]
            });
            for (var i in toolBox.tools) {
                tool = toolBox.tools[i];
                if (this.exp.getVar(tool.n_id, this.gvars) > 0) {
                    toolInfo = {
                        id: tool.id,
                        resid: tool.resid,
                        num: this.exp.getVar(tool.n_id, this.gvars),
                        n_id: tool.n_id
                    };
                } else {
                    toolInfo = null;
                }
                cmds = [];
                cmds.push(["delToolVars", null, null]);
                if (toolInfo != null) {
                    toolInfo["tag"] = "tool" + tool.id;
                    cmds.push(["def", toolInfo["tag"], "expression 1", "global"]);
                    toolInfo.cmds = cmds;
                    tools.push(toolInfo);
                }
            }
            return tools;
        }
        p.clrVars = function() {
            this.vars = {
                __up__: this.gvars
            };
        }
        p.delVarWithTool = function() {
            for (var i in this.gvars) {
                if (i.indexOf("tool") > -1) {
                    delete this.gvars[i];
                    // this.vars[i] = 0;
                }
            }
        }
        p.addEvent = function(id, filter, cmds) {
            this.events[id] = {
                filter: filter,
                cmds: cmds
            };
        }
        p.clrEvent = function() {
            this.events = {};
        }
        p.doEventWithFilter = function(filter, cmds, argvs) {
            if (this.exp.expression(filter, this.vars)) {
                this.doCmds(cmds, argvs);
            }
        }
        p.checkNumberPay = function(filter, cmds, argvs) {
            if (filter && filter.indexOf('~') > -1) {
                var $that = this;
                this.content.net.pay(filter.split("~")[0], function() {
                    var evt = {
                        filter: filter.split('~')[1],
                        cmds: cmds
                    }
                    if (evt.filter != "") {
                        $that.doEventWithFilter(evt.filter, cmds, argvs);
                    } else {
                        $that.doCmds(evt.cmds, argvs);
                    }
                });
            } else if (filter && filter.length > 0) {
                this.doEventWithFilter(filter, cmds, argvs);
            } else {
                this.doCmds(cmds, argvs);
            }
        }
        p.trigerEvent = function(id, argvs) {
            if (this.events[id]) {
                var flag = true;
                if (this.events[id].filter) {
                    if (typeof this.events[id].filter == 'object') {
                        //条件序列
                        var filterArr = this.events[id].filter;
                        for (var i in filterArr) {
                            if (this.filterArrStop) continue;
                            var filter_cmds = filterArr[i];
                            var filter = filter_cmds[0];
                            var cmds = filter_cmds[1];
                            this.checkNumberPay(filter, cmds, argvs);
                            // if (this.exp.expression(filter, this.vars)) {
                            //     this.doCmds(cmds, argvs);
                            // }
                        }
                    } else {
                        //单个条件
                        this.checkNumberPay(this.events[id].filter, this.events[id].cmds, argvs);
                        // if (this.exp.expression(this.events[id].filter, this.vars)) {
                        //     this.doCmds(this.events[id].cmds, argvs);
                        // }
                    }
                    flag = true;
                } else {
                    this.doCmds(this.events[id].cmds, argvs);
                    flag = false;
                }
                // if (this.events[id].filter) {
                //     if (this.exp.expression(this.events[id].filter, this.vars)) {
                //         this.doCmds(this.events[id].cmds, argvs);
                //     }
                // } else {
                //     this.doCmds(this.events[id].cmds, argvs);
                // }
                this.filterArrStop = false;
                return flag;
            }
            return false;
        }
        p.pause = function(value) {
            this.stopNext = value ? true : false;
            this.tapNext = !this.animating;
        }
        p.waitAnimateEnd = function() {
            this.animating = true;
            this.content.vortexWaitAnimEnd();
        }
        p.processEventData = function(evt, type) {
            if (!evt) return;
            if (evt.evt) {
                this.trigerEvent(type + evt.evt, evt.argvs);
                return;
            }
            if (evt.cmds) {
                this.doCmds(evt.cmds, evt.argvs);
                return;
            }
        }
        p.onClipEvt = function(evt) {
            this.trigerEvent("clip." + evt);
        }
        p.onTapEvt = function(evt) {
            if (this.trigerEvent("tap." + evt)) {
                return true;
            }
            if (this.tapNext) {
                this.tapNext = false;
                this.trigerEvent("tap.end");
                return false;
            }
            return false;
        }
        p.onAnimEvt = function(evt) {
            if (evt === "end") {
                if (this.animating) {
                    this.animating = false;
                    this.tapNext = this.stopNext ? false : true;
                    this.trigerEvent("anim.end");
                }
                return;
            }
            return this.processEventData(evt, "anim.");
        }
        p.onGameEvt = function(evt) {
            this.pause(false);
            return this.processEventData(evt, "game.");
        }
        p.defToolEvt = function(cmds) {
            this.doCmds(cmds, null);
        }
        return vm;
    })();
    vortex.vm = vm;
})(vortex || (vortex = {}));
////