define(function(reqire, exoprts, module){
	var _eventProxy = {};
    var Scene = {},
        musicCount = 0,
        loadedMsic = 0;
    var musicList = {};
    var MusicNow = {};
    var isMusicAllowPlay = true;
    var openFrom = request('type');
    var ua = navigator.userAgent.toLowerCase();
    /**
     * [loadMusicFromBox 开始下载音乐]
     * @param  {[string]} musicStr [音乐Id组成的字符串以逗号隔开]
     */
    function loadMusicFromBox(musicStr){
        if(openFrom == 'box'){
            if (/android/.test(ua)) {

            } else {
                ocPreDownLoadMusic(musicStr);
            }
        }
	}
	module.exports.loadMusicFromBox = loadMusicFromBox;

    /**
     * [getMusicIdByType 根据音乐类型获取音乐id]
     * @param  {[type]} type [description]
     */
    function getMusicIdByType(type){
        for(var i in MusicNow){
            if(MusicNow[i].type == type){
                return i;
            }
        }
        return false;
    }

	// 事件处理对象
    module.exports.eventProxy = function(_ep) {
        _eventProxy = _ep;
        if(/iphone|ipad|ipod|iOS/.test(ua) && openFrom == 'box'){
            ocResumeAllMuscVolume();
        }
        //开始下载音乐
        _eventProxy.on('loadMusicInBox', function(listStr, scene, type){
            Scene = scene;
            var list = listStr.split(',');
            _.each(list, function(elem, key){
                if(musicList[key] && musicList[key].statu)
                    list.splice(key, 1);
            });
            if(list.length > 0){
                listStr = '';
                for(var i in list){
                    if(i == list.length - 1){
                        listStr += list[i];
                    } else {
                        listStr = listStr + list[i] + ',';
                    }
                }
                musicCount = listStr.split(',').length;
                loadedMsic = 0;
                loadMusicFromBox(listStr);
            } else {
                _eventProxy.trigger('afterLoadMusicInBox', Scene);
            }
            // loadMusicFromBox(listStr);
        });

        //标记音乐类型
        _eventProxy.on('markMusic', function(musicId, type){
            musicList[musicId] = {
                id: musicId,
                type: type
            }
        });

        //播放音乐
        _eventProxy.on('playMusicInBox', function(musicId, type){
            _eventProxy.trigger('markMusic', musicId, type);
            musicList[musicId]['statu'] = 2;
            if(!MusicNow[musicId]) {
                var oldMusicId = getMusicIdByType(type);
                if(oldMusicId){
                    delete MusicNow[oldMusicId];
                    // if(type == 'music'){
                        ocStopMusic(oldMusicId);
                    // }
                }
                MusicNow[musicId] = {
                    id: musicId,
                    type: type
                };
                ocPlayMusic(musicId, type == 'music' ? '1' : '-1');
                if(isMusicAllowPlay)
                    ocCloseAllMuscVolume
            }
        });
        //关闭正在播放的音乐
        _eventProxy.on('closeTempMusicInBox', function(type){
            var musicId = getMusicIdByType(type);
            if(musicId){
                delete MusicNow[musicId];
                // if(type == 'music'){
                    ocStopMusic(musicId);
                // }
            }
        });
        //开音乐
        _eventProxy.on('turnOnMusicInBox', function(){
            isMusicAllowPlay = true;
            for(var i in MusicNow){
                if(MusicNow[i]['statu'] == 1){
                    ocPlayMusic(musicId, MusicNow[i]['type'] == 'music' ? '1' : '-1');
                }
           
           }
            ocResumeAllMuscVolume();
        });

        //关音乐
        _eventProxy.on('turnOffMusicInBox', function(){
            isMusicAllowPlay = false;
            ocCloseAllMuscVolume();
        });
    }

    /**
     * [afterLoadMusic 盒子里下载玩音乐后的回调]
     * @param  {[string]} musicId [音乐Id]
     */
    function afterLoadMusic(musicId){
        // var list = [];
        // list.push({
        //     id: musicId,
        //     path: ocGetMusicLocalPathByID(musicId),
        //     attr: 'music',
        //     type: 'audio'
        // });

        // resourceModule.loadList(list, function() {
        //     _eventProxy.trigger('afterLoadMusicInBox', Scene);
        // });
        
        musicList[musicId]['statu'] = 1;
        if(!(Scene.sound && Scene.sound.resid)){
            var soundId = getMusicIdByType('sound');
            if(getMusicIdByType('sound')){
                delete MusicNow[soundId];
            }
        }
        loadedMsic++;
        if(loadedMsic == musicCount){
            _eventProxy.trigger('afterLoadMusicInBox', Scene);
        }
        // _eventProxy.trigger('afterLoadMusicInBox', Scene);
    }

    window.afterLoadMusic = afterLoadMusic;

})