//TODO 生成不直接消除,包括第一次和新的.
//TODO 不能消除检测
//TODO 布局编辑器.
//TODO 格子逻辑额外逻辑
(function() {
	const GAMEID = "three";
	var Main = (function(_super) {
		__extends(Main, _super);

		function Main() {
			_super.call(this);
			this.baseurl = "bin/game/" + GAMEID + "/";
			this.gameid = GAMEID;
			this.exp = new vortex.exp();
		}
		var d = __define,
			c = Main,
			p = c.prototype;
		p.processProp = Vortex.processProp;
		p.destroy = function() {
			_super.prototype.destroy.call(this);
		};
		p.create = function() {
			this._res_ui = this.getRes("ui_json");
			console.log(this);
			this.panelGame = new PanelGame();
			this.addChild(this.panelGame);
			this.processProp(this._res_ui.data ? this._res_ui.data : {});
			if (this.width > this.height) {
				this.processProp(this._res_ui.dataheng ? this._res_ui.dataheng : {});
			} else {
				this.processProp(this._res_ui.datashu ? this._res_ui.datashu : {});
			}
			this.panelGame.init();
			this.panelGame.start();
		}
		return Main;
	}(VortexGame.GameBase));
	VortexGame.GameManager.regGame(GAMEID, Main);
	var PanelGame = (function(_super) {
		__extends(PanelGame, _super);

		function PanelGame() {
			_super.call(this);
			this.data = {
				types: [0xFF0000, 0x00FF00, 0x0000FF, 0xFFFF00, 0xFF00FF, 0x00FFFF]
			};
			this.game = {};
			this.num_row = 9;
			this.num_col = 9;
			this.rows = [];
			for (var i = 0; i < this.num_row; i++) {
				this.rows.push([]);
			}
			this.game.data = [];
			for (var i = 0; i < this.num_row; i++) {
				this.game.data.push([]);
				for (var j = 0; j < this.num_col; j++) {
					this.game.data[i][j] = this.data.types[Math.floor(this.data.types.length * Math.random())];
				}
			}
		}
		var d = __define,
			c = PanelGame,
			p = c.prototype;
		p.destroy = function() {
			this.removeEventListener(egret.TouchEvent.TOUCH_BEGIN, this.handleTouchBegin, this);
		}
		p.init = function() {
			this.addEventListener(egret.TouchEvent.TOUCH_BEGIN, this.handleTouchBegin, this);
			this.mask = new egret.Rectangle(0, 0, this.width, this.height);
			this.touchEnabled = true;
			this.graphics.beginFill(0x333333);
			this.graphics.drawRect(0, 0, this.width, this.height);
			this.graphics.endFill();
			this.block_width = this.width / this.num_col;
			this.line_height = this.height / this.num_row;
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					var block = new egret.TextField();
					block.background = true;
					block.textColor = 0x0;
					block.width = this.block_width, block.height = this.line_height;
					this.rows[i][j] = {
						block: block,
						type: this.game.data[i][j],
						elim: 0,
					};
					this.addChild(block);
				}
			}
		}
		p.handleTouchBegin = function(evt) {
			if (!this.canMove) return;
			this.stage.addEventListener(egret.TouchEvent.TOUCH_END, this.handleTouchEnd, this);
			this.stage.addEventListener(egret.TouchEvent.TOUCH_MOVE, this.handleTouchMove, this);
			this.touchX = evt.localX;
			this.touchY = evt.localY;
			this.touchSX = evt.stageX;
			this.touchSY = evt.stageY;
		}
		p.handleTouchEnd = function(evt) {
			this.stage.removeEventListener(egret.TouchEvent.TOUCH_END, this.handleTouchEnd, this);
			this.stage.removeEventListener(egret.TouchEvent.TOUCH_MOVE, this.handleTouchMove, this);
		}
		p.switchCell = function(cx, cy, mx, my, back) {
			var self = this;
			var frCell = this.getCell(cy, cx);
			var toCell = this.getCell(cy + my, cx + mx);
			if (frCell && toCell) {
				this.rows[frCell.y][frCell.x] = toCell;
				this.rows[toCell.y][toCell.x] = frCell;
				frCell.x = toCell.x, frCell.y = toCell.y;
				toCell.x = cx, toCell.y = cy;
				this.canMove = false;
				var tw;
				tw = egret.Tween.get(frCell.block);
				tw.to({
					x: frCell.x * this.block_width,
					y: frCell.y * this.line_height
				}, 200);
				tw = egret.Tween.get(toCell.block);
				tw.to({
					x: toCell.x * this.block_width,
					y: toCell.y * this.line_height
				}, 200);
				if (!back) {
					tw.wait(20);
					tw.call(function() {
						if (!self.eliminate()) {
							self.switchCell(cx, cy, mx, my, true);
						}
					});
				} else {
					tw.wait(20);
					tw.call(function() {
						self.canMove = true;
					});
				}
			}
		}
		p.handleTouchMove = function(evt) {
			if (!this.canMove) return;
			var diffx = evt.stageX - this.touchSX;
			var diffy = evt.stageY - this.touchSY;
			if (Math.abs(diffx) + Math.abs(diffy) < this.line_height * 0.5) {
				return;
			}
			var x = 0;
			var y = 0;
			if (Math.abs(diffx) > Math.abs(diffy)) {
				if (diffx < 0) {
					x = -1;
				} else {
					x = 1;
				}
			} else {
				if (diffy < 0) {
					y = -1;
				} else {
					y = 1;
				}
			}
			var cx = Math.floor(this.touchX / this.block_width);
			var cy = Math.floor(this.touchY / this.line_height);
			this.switchCell(cx, cy, x, y);
		}
		p.start = function() {
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					var data = this.rows[i][j];
					egret.Tween.removeTweens(data.block);
					data.type = this.game.data[i][j];
					data.elim = 0;
					data.x = j;
					data.y = i;
					var block = data.block;
					block.alpha = 1.0;
					block.x = j * this.block_width;
					block.y = i * this.line_height;
					this.showCell(data);
				}
			}
			this.canMove = false;
			egret.callLater(this.eliminate, this);
		}
		p.showCell = function(data) {
			data.block.alpha = 1.0;
			data.block.backgroundColor = data.type;
		}
		p.getCell = function(i, j) {
			if (i < 0 || i >= this.num_row) {
				return null;
			}
			if (j < 0 || j >= this.num_col) {
				return null;
			}
			return this.rows[i][j];
		}
		p.eliminate = function() {
			var self = this;
			var elim_cell = function(i, j) {
				var cell = self.getCell(i, j);
				var xl = 0;
				for (var x = 1; x < self.num_col; x++) {
					var c = self.getCell(i, j + x);
					if (c && c.type == cell.type) {
						xl++;
					} else {
						break;
					}
				}
				for (var x = -1; x > -self.num_col; x--) {
					var c = self.getCell(i, j + x);
					if (c && c.type == cell.type) {
						xl++;
					} else {
						break;
					}
				}
				if (xl > 1) {
					cell.elim = xl;
				}
				var yl = 0;
				for (var y = 1; y < self.num_row; y++) {
					var c = self.getCell(i + y, j);
					if (c && c.type == cell.type) {
						yl++;
					} else {
						break;
					}
				}
				for (var y = -1; y > -self.num_row; y--) {
					var c = self.getCell(i + y, j);
					if (c && c.type == cell.type) {
						yl++;
					} else {
						break;
					}
				}
				if (yl > 1) {
					cell.elim += yl;
				}
				if (cell.elim > 0) {
					cell.elim++;
				}
			}
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					elim_cell(i, j);
				}
			}
			var tw;
			for (var i = 0; i < this.num_row; i++) {
				for (var j = 0; j < this.num_col; j++) {
					var data = this.rows[i][j];
					var block = data.block;
					//block.text = data.elim;
					if (data.elim >= 3) {
						tw = egret.Tween.get(block);
						tw.to({
							alpha: 0.0
						}, 300);
					}
				}
			}
			if (tw) {
				tw.wait(20);
				tw.call(this.drop, this);
				return true;
			} else {
				this.canMove = true;
			}
			return false;
		}
		p.drop = function() {
			var self = this;
			var up = [];
			for (var j = 0; j < this.num_col; j++) {
				up[j] = 1;
			}
			for (var i = this.num_row - 1; i >= 0; i--) {
				for (var j = 0; j < this.num_col; j++) {
					var data = this.rows[i][j];
					if (data.elim >= 3) {
						var next = null;
						for (var y = 1; y < this.num_row; y++) {
							var n = self.getCell(i - y, j);
							if (!n) break;
							if (n.elim >= 3) continue;
							next = n;
							break;
						}
						if (next) {
							data.y = next.y;
							this.rows[next.y][next.x] = data;
							next.y = i;
							this.rows[i][j] = next;
						} else {
							data.type = this.data.types[Math.floor(this.data.types.length * Math.random())];
							data.block.y = -(up[j] * this.line_height);
							up[j] = up[j] + 1;
							data.elim = 0;
							egret.Tween.removeTweens(data.block);
							this.showCell(data);
						}
					}
				}
			}
			var tw;
			for (var i = this.num_row - 1; i >= 0; i--) {
				for (var j = 0; j < this.num_col; j++) {
					var data = this.rows[i][j];
					var y = data.y * this.line_height;
					if (data.block.y != y) {
						tw = egret.Tween.get(data.block);
						tw.to({
							y: y
						}, 300, egret.Ease.backInOut);
					}
				}
			}
			if (tw) {
				tw.wait(20);
				tw.call(this.eliminate, this);
			} else {
				this.canMove = true;
			}
		}
		return PanelGame;
	})(egret.Sprite);
})();



////