var GameTxtopt;
(function(GameTxtopt) {
	const GAMEID = "txtopt";
	var GameTextSelect = (function(_super) {
		__extends(GameTextSelect, _super);

		function GameTextSelect(params) {
			_super.call(this);
			this.baseurl = "bin/game/txtopt/";
			this.gameid = GAMEID;
			this.params = params;
			//这里先暂时这么传递.皮肤逻辑整理后再整改这里.
			this.skinname = params.skinname;
			this.res = params.skinres;
			this.content = params.content;
		}
		var d = __define,
			c = GameTextSelect,
			p = c.prototype;
		p.destroy = function() {
			this.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			_super.prototype.destroy.call(this);
		}
		p.create = function() {
			this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
			var h = 0;
			var cellheight = this.res["branch"].h;
			for (var i in this.params.data) {
				h = h + cellheight;
			}
			var p = (this.stage.stageHeight - 120) * 0.5 - h * 0.5;
			for (var i in this.params.data) {
				var t = this.params.data[i];
				if(!t.text) continue;
				t.cmds = [
					["goto", t.skip]
				];
				var bm = new egret.Bitmap();
				bm.name = "branch";
				bm.touchEnabled = true;
				bm.texture = RES.getRes(this.skinname + "." + this.res[bm.name].background);
				bm.x = this.stage.stageWidth * 0.5 - bm.width * 0.5;
				bm.y = p;
				this.addChild(bm);
				var tf = new egret.TextField();
				tf.name = i;
				tf.textFlow = new egret.HtmlTextParser().parser(t.text ? t.text : "");
				tf.touchEnabled = false;
				this.addChild(tf);
				tf.width = this.res[bm.name].w;
				tf.height = this.res[bm.name].h;
				tf.x = this.stage.stageWidth * 0.5 - tf.width * 0.5;
				tf.y = bm.y+bm.height/2.0 - tf.height/2.0;
				p = p + this.res[bm.name].h + 10;
				tf.textAlign = "center";
				tf.verticalAlign = egret.VerticalAlign.MIDDLE;
				tf.fontFamily = this.res["mainui"].fontFamily;
				tf.textColor = this.content.vt.script.global.color ? this.content.vt.script.global.color : this.res["mainui"].color;

				bm.tfName = tf.name;
				this.iconAddMouseOverEventWithTarget(bm);
				this.iconAddMouseOutEventWithTarget(bm);
			}
		}
		p.handleTap = function(event) {
			var n = event.target.tfName;
			this.content.addReviewIds(n.replace('Text',''));
			var o = this.getChildByName(event.target.tfName);
			this.content.addReviewText(o.text);	//添加剧情回放
			for (var i in this.params.data) {
				if (i == n) {
					this.dispatchEventWith("game_over", true, {
						result: "ok",
						key: i,
						cmds: this.params.data[i].cmds
					}, false);

				}
			}
		}

		p.iconAddMouseOverEventWithTarget = function(target) {
			if (_typeBox == 'box') {
				return;
			}
	        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
	    };
	    p.iconAddMouseOutEventWithTarget = function(target) {
	    	if (_typeBox == 'box') {
				return;
			}
	        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
	    };
	    p.iconMoveOver = function(event) {
	        var name = event.target.name;
	        var res = this.res;
	        event.target.texture = RES.getRes(res[name].background_activated);
	    };
	    p.iconMoveOut = function(event) {
	        var name = event.target.name;
	        var res = this.res;
	        event.target.texture = RES.getRes(res[name].background);
	    };

		return GameTextSelect;
	}(VortexGame.GameKid));
	egret.registerClass(GameTextSelect, 'GameTxtopt.GameTextSelect');
	VortexGame.GameManager.regGame("txtopt", GameTextSelect);
})(GameTxtopt || (GameTxtopt = {}));



////