var VortexUI;
(function(VortexUI) {
	var Btn = (function(_super) {
		__extends(Btn, _super);

		function Btn(upTex, downTex) {
			_super.call(this);
			this.upImg = new egret.Bitmap(upTex);
			this.downImg = new egret.Bitmap(downTex);
			this.downImg.visible = false;
			this.touchEnabled = true;
			this.addChild(this.upImg);
			this.addChild(this.downImg);
			this.addEventListener(egret.TouchEvent.TOUCH_BEGIN, this.downHandler, this);
			this.addEventListener(egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.upHandler, this);
			this.addEventListener(egret.TouchEvent.TOUCH_END, this.upHandler, this);
		}
		var d = __define,
			c = Btn,
			p = c.prototype;
		p.destroy = function() {
			this.removeEventListener(egret.TouchEvent.TOUCH_BEGIN, this.downHandler, this);
			this.removeEventListener(egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.upHandler, this);
			this.removeEventListener(egret.TouchEvent.TOUCH_END, this.upHandler, this);
			this.removeChild(this.upImg);
			this.removeChild(this.downImg);
		}
		p.downHandler = function(evt) {
			this.downImg.visible = true;
			this.upImg.visible = false;
		};
		p.upHandler = function(evt) {
			this.downImg.visible = false;
			this.upImg.visible = true;
		};
		return Btn;
	}(egret.DisplayObjectContainer));
	egret.registerClass(Btn, 'VortexUI.Btn');
	VortexUI.Btn = Btn;
})(VortexUI || (VortexUI = {}));


////