//这里是界面的总控
var Continue = (function(_super) {
    __extends(Continue, _super);

    function Continue(argvs) {
        _super.call(this);
        this.content = argvs.content;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = Continue,
        p = c.prototype;
    p.onAddToStage = function(event) {
        var argvs = {
            content: this.content,
            super: this
        };
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.touchEnabled = true;
        //启用舞台的鼠标支持
        (_typeBox != 'box')?mouse.enable(this.stage):1;
        this.container = new egret.Sprite();
        this.addChild(this.container);
        //防止点击事件穿透
        this.graphics.beginFill(0x000000, 1);
        this.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
        this.graphics.endFill();
        this.bg = new egret.Bitmap();
        this.bg.name = "selectBg";
        this.container.addChild(this.bg);
        this.setBg(this.bg);
        this.setOption(this.bg);
        this.tips = new egret.TextField();
        this.tips.name = "continueTips";
        this.tips.text = "是否继续故事";
        this.container.addChild(this.tips);
        this.tips.visible = true;
        this.setOption(this.tips);
        this.confirm = new egret.Bitmap();
        this.confirm.name = "confirmContinue";
        this.confirm.touchEnabled = true;
        this.container.addChild(this.confirm);
        this.setBg(this.confirm);
        this.setOption(this.confirm);
        this.cancel = new egret.Bitmap();
        this.cancel.name = "cancelContinue";
        this.cancel.touchEnabled = true;
        this.container.addChild(this.cancel);
        this.setBg(this.cancel);
        this.setOption(this.cancel);
    }
    p.setBg = function(item) {
        item.texture = RES.getRes(item.name);
    }
    p.setOption = function(item) {
        this.container.width = RES.getRes("common")["selectBg"].width;
        this.container.height = RES.getRes("common")["selectBg"].height;
        for (var i in RES.getRes("common")[item.name]) {
            item[i] = RES.getRes("common")[item.name][i];
        }
    }
    p.distroy = function() {
        while (this.numChildren) {
            var dobj = this.removeChildAt(0);
            if (dobj.destroy) {
                dobj.destroy();
            }
        }
    }
    p.handleTap = function(event) {
        if (isWeiXin() || isSafari()) {
            var sd = RES.getRes('defaultBgm');
            this.content.bgm = sd.play();
            this.content.bgm.stop();
        };
        var name = event.target.name;
        if (name == this.confirm.name) {
            //选择继续游戏
            this.content.continueGame(this.gameId, true);
            // this.visible = false;
            this.distroy();
        } else if (name == this.cancel.name) {
            //选择不继续游戏
            this.content.continueGame(this.gameId, false);
            // this.visible = false;
            this.distroy();
        }
        event.stopPropagation();
    }
    p.showSelectStart = function(gameId) {
        this.visible = true;
        this.gameId = gameId;
        this.container.x = (this.width - this.container.width) / 2;
        this.container.y = (this.height - this.container.height) / 2;
    }
    return Continue;
}(egret.Sprite));
egret.registerClass(Continue, 'Continue');
////