//end.js 游戏结束时菜单页面
//ly
var UIEnd = (function(_super) {
    __extends(UIEnd, _super);

    function UIEnd(argvs) {
        _super.call(this);
        this.super = argvs.super;
        this.content = argvs.content;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = UIEnd,
        p = c.prototype;
    p.onAddToStage = function() {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.touchEnabled = true;
        var argvs = {
            content: this.content,
            super: this
        }
        this.container = this.super.getContainer("review_layout");
        this.container.visible = true;
        this.addChild(this.container);
        //防止点击事件穿透
        this.graphics.beginFill(0x000000, 0.9);
        this.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
        this.graphics.endFill();
        this.width = this.super.width;
        this.height = this.super.height;
        this.itemBgArray = new Array();
        //背景
        this.contentBg = this.addBitmapItem("UIEnd_contentBg");
        this.container.addChild(this.contentBg);
        this.itemBgArray.push(this.contentBg);
        //标题
        this.titlebg = this.addBitmapItem("UIEnd_title");
        this.container.addChild(this.titlebg);
        this.itemBgArray.push(this.titlebg);
        this.endItemArray = new Array();
        var nameArray = ["UIEnd_temp", "UIEnd_forever", "UIEnd_restart", "UIEnd_share"];
        for (var i = 0; i < nameArray.length; i++) {
            var itemName = nameArray[i];
            var itemBg = this.addBitmapItem(itemName);
            itemBg.tag = i;
            this.container.addChild(itemBg);
            this.endItemArray.push(itemBg);
        }
        //退出按钮
        this.exitBtn = this.addBitmapItem("UIEnd_exit");
        this.container.addChild(this.exitBtn);
        this.itemBgArray.push(this.exitBtn);
        this.iconAddMouseOverEventWithTarget(this.exitBtn);
        this.iconAddMouseOutEventWithTarget(this.exitBtn);
        this.temporary = new Temporary(argvs);
        this.temporary.visible = false;
        this.addChild(this.temporary);
        this.forever = new Forever(argvs);
        this.forever.visible = false;
        this.addChild(this.forever);
        this.share = new UIShare(argvs);
        this.share.visible = false;
        this.addChild(this.share);
        this.hideExit();
    }
    p.setSkin = function(skinname, res) {
        for (var i = 0; i < this.itemBgArray.length; i++) {
            var item = this.itemBgArray[i];
            item.x = res[item.name].x;
            item.y = res[item.name].y;
            item.texture = RES.getRes(res[item.name].background);
        }
        for (var i = 0; i < this.endItemArray.length; i++) {
            var tItem = this.endItemArray[i];
            var tName = tItem.name;
            tItem.x = res[tName].x;
            tItem.y = res[tName].y;
            tItem.texture = RES.getRes(res[tName].background);
            this.iconAddMouseOverEventWithTarget(tItem);
            this.iconAddMouseOutEventWithTarget(tItem);
        }
        this.temporary.setSkin(skinname, res);
        this.forever.setSkin(skinname, res);
        this.share.setSkin(skinname, res);
        this.totalRes = res;
    }
    p.handleTap = function(event) {
        var self = this;
        event.stopPropagation();
        var name = event.target.name;
        if (name == this.exitBtn.name) {
          
            if (this.super.boxExit()) {
                return;
            };
            // window.close();
            // window.location.href = Config.official;
            // this.visible = false;
            // this.super.HideUIExceptMenu(this.visible);
        } else if (name == this.endItemArray[0].name) {
            //临时存储 
            this.content.read({
                type: 1
            }, function(data) {
                if (typeof data != 'undefined' && typeof data.msg != 'undefined') {
                    self.temporary.render(data.msg);
                };
                self.wantHideOthersButTarget(self.temporary);
            });
        } else if (name == this.endItemArray[1].name) {
            //永久存储
            this.content.read({
                type: 2
            }, function(data) {
                if (typeof data != 'undefined' && typeof data.msg != 'undefined') {
                    self.forever.render(data.msg);
                };
                self.wantHideOthersButTarget(self.forever);
            });
        } else if (name == this.endItemArray[2].name) {
            //重新开始
            this.content.clearReviewText();
            this.content.clearAvatarFrossmGlobal();
            restart();
            this.visible = false;
            this.super.HideUIExceptMenu(false);
            this.content.vortexBgm(null, null);
            this.content.vortexClearSound();
            this.content.vortexClearVoice();
        } else if (name == this.endItemArray[3].name) {
            //分享
            if (this.super.boxShare()) {
                return;
            };
            this.wantHideOthersButTarget(this.share);
        }
    }
    p.addBitmapItem = function(name) {
            var item = new egret.Bitmap();
            item.touchEnabled = true;
            item.name = name;
            return item;
        }
        //文本
    p.addTxtItem = function(o) {
        var txItem = new egret.TextField;
        txItem.name = o;
        txItem.type = egret.TextFieldType.DYNAMIC;
        return txItem;
    }
    p.wantHideOthersButTarget = function(tar) {
        for (var i = 0; i < this.itemBgArray.length; i++) {
            var item = this.itemBgArray[i];
            item.visible = false;
        }
        for (var i = 0; i < this.endItemArray.length; i++) {
            var tItem = this.endItemArray[i];
            tItem.visible = false;
        }
        tar.visible = true;
        this.hideExit();
    }
    p.AllMeunItemShowOrHide = function(flag) {
        for (var i = 0; i < this.itemBgArray.length; i++) {
            var item = this.itemBgArray[i];
            item.visible = flag;
        }
        for (var i = 0; i < this.endItemArray.length; i++) {
            var tItem = this.endItemArray[i];
            tItem.visible = flag;
        }
        this.hideExit();
    }
    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background);
    };
    p.hideExit = function() {
        if (_typeBox == "box") {
            this.exitBtn.visible = true;
        } else {
            this.exitBtn.visible = false;
        }
    };
    return UIEnd;
}(egret.Sprite));
egret.registerClass(UIEnd, 'UIEnd');