//永久存储
// ly
var Forever = (function(_super) {
    __extends(Forever, _super);

    function Forever(argvs) {
        _super.call(this);
        this.content = argvs.content;
        this.super = argvs.super;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = Forever,
        p = c.prototype;
    p.onAddToStage = function() {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.touchEnabled = true;
        this.width = this.super.width;
        this.height = this.super.height;

        this.container = this.super.super.getContainer("forever");
        this.container.visible = true;
        this.addChild(this.container);

        this.itemBgArray = new Array();
        //背景
        this.contentBg = this.addBitmapItem("forever_contentBg");
        this.container.addChild(this.contentBg);
        this.itemBgArray.push(this.contentBg);
        //标题
        this.titlebg = this.addBitmapItem("forever_title");
        this.container.addChild(this.titlebg);
        this.itemBgArray.push(this.titlebg);
        //6个按钮
        this.foreverArray = new Array();
        //6个标题
        this.itemTitleArray = new Array();
        //6个内容
        this.itemContentArray = new Array();
        //6个临时存储
        var itemNameArray = ["forever_One", "forever_Two", "forever_Three", "forever_Four", "forever_Five", "forever_Six"];
        var txName = "forever_label";
        for (var i = 0; i < 6; i++) {
            var itemName = itemNameArray[i];
            var itemBg = this.addBitmapItem(itemName);
            itemBg.tag = i;
            this.container.addChild(itemBg);
            this.foreverArray.push(itemBg);
            var txItem = this.addTimeItem();
            txItem.name = txName;
            this.container.addChild(txItem);
            this.itemTitleArray.push(txItem);

            var itemContent = this.addBitmapItem("");
            itemContent.tag = i + 100;
            this.container.addChild(itemContent);
            this.itemContentArray.push(itemContent);
        }
        //左侧按钮
        this.leftBtn = this.addBitmapItem("forever_left");
        this.leftBtn.visible = false;
        this.container.addChild(this.leftBtn);
        this.itemBgArray.push(this.leftBtn);
        //右侧按钮
        this.rightBtn = this.addBitmapItem("forever_right");
        this.rightBtn.visible = false;
        this.container.addChild(this.rightBtn);
        this.itemBgArray.push(this.rightBtn);
        //用户读档
        this.userBtn = this.addBitmapItem("forever_user");
        this.container.addChild(this.userBtn);
        this.itemBgArray.push(this.userBtn);
        //系统读档
        this.systemBtn = this.addBitmapItem("forever_system");
        this.container.addChild(this.systemBtn);
        this.itemBgArray.push(this.systemBtn);
        //返回按钮
        this.backBtn = this.addBitmapItem("forever_back");
        this.addChild(this.backBtn);
        this.itemBgArray.push(this.backBtn);
        this.content.saveDocumentPage = 1;

        var tipItem = new egret.TextField;
        tipItem.textAlign = egret.HorizontalAlign.CENTER;
        tipItem.verticalAlign = egret.VerticalAlign.MIDDLE;
        tipItem.type = egret.TextFieldType.DYNAMIC;
        tipItem.text = "作者忘记设置永久存储了";
        tipItem.size = 35;
        tipItem.width  = 500;
        tipItem.height = 60;
        tipItem.x = (this.width-tipItem.width)/2.0;
        tipItem.y = (this.height-tipItem.height)/2.0;
        tipItem.visible = false;
        this.tipItem = tipItem;
        this.addChild(tipItem);

    }
    p.clear = function() {
        //还原成初始化的状态
        for (var i = 0; i < this.foreverArray.length; i++) {
            var tItem = this.foreverArray[i];
            tItem.visible = true;
            tItem.texture = RES.getRes(this.totalRes[tItem.name].background);
            var txItem = this.itemTitleArray[i];
            txItem.text = "";

            var cItem = this.itemContentArray[i];
            cItem.visible = true;
            cItem.texture = null;
            cItem.saveDocumentData = null;

        }

        this.maxCount = this.content.totalSaveNum;
        if (this.maxCount < 1) 
        {
            this.tipItem.visible = true;
        }else
        {
            this.tipItem.visible = false;
        }
    }
    p.render = function(data) {
        this.clear();

        //左右翻页按钮的显示
        if (this.content.saveDocumentPage > 1) {
            this.leftBtn.visible = true;
        } else {
            this.leftBtn.visible = false;
        }
        var maxpages = Math.ceil(this.maxCount / 6);
        var showNum = 6;
        if (this.content.saveDocumentPage == maxpages||this.maxCount==0) {
            showNum = 6 - (this.content.saveDocumentPage * 6 - this.maxCount)
            this.rightBtn.visible = false;
        } else {
            this.rightBtn.visible = true;
        }
        //存档内容的显示
        var self = this;
        var render_arr = {};
        var conter = data.conter;
        console.log(data.result);       
        for (var i = 0; i < this.itemContentArray.length; i++) {
            var saveDocumentData = data.result[i];
            var cItem = this.itemContentArray[i];
            var tItem = this.foreverArray[i];
            if (saveDocumentData) {
                cItem.visible = true;
                var imgid = "savePic/" + this.content.vt.script.gameId + "/" + saveDocumentData.sceneId + ".png&" + new Date().getTime();
                cItem.saveDocumentData = saveDocumentData;
                render_arr[imgid] = cItem;
                this.content.net.getImgFs(imgid, function(texture,key) {
                    var ccItem = render_arr[key];
                    ccItem.texture = texture;
                });
                var txItem = this.itemTitleArray[i];
                txItem.text = saveDocumentData.SCENE.datetime;
            }
            if (i >= showNum) 
            {
                //超过显示个数则隐藏
                cItem.visible = false;
                tItem.visible = false;
            }
        }
    }
    p.setSkin = function(skinname, res) {
        for (var i = 0; i < this.itemBgArray.length; i++) {
            var item = this.itemBgArray[i];
            if (!res.hasOwnProperty(item.name)) {
                continue;
            }
            var dict = res[item.name];
            var rStr = dict.background;
            if (item.name === this.userBtn.name) {
                rStr = dict.background_activated;
            }
            item.texture = RES.getRes(rStr);
            item.x = res[item.name].x;
            item.y = res[item.name].y;
            if (dict.hasOwnProperty("visible")) {
                var vStr = dict.visible;
                if (vStr === "false") {
                    item.visible = false;
                } else {
                    item.visible = true;
                }
            }
        }

        var backBtnPs = ["## $sw - "+this.backBtn.x,this.backBtn.y,null,null,"## $w",0];
        this.super.super.positonParameters(this.backBtn,backBtnPs);

        var txName = this.itemTitleArray[0].name;
        //这个参数判断时间显示在图片里面还是图片外。(eg.水墨是显示在图片里,默认显示在图片外)
        // 取值 1 or -1；
        var txIsOut = 1;
        if (res[txName].hasOwnProperty("isOut")) {
            txIsOut = res[txName].isOut;
        }
        var marginToPic = 20;
        if (res[txName].hasOwnProperty("marginToPic")) {
            marginToPic = res[txName].marginToPic;
        }
        var txRelativeY = marginToPic * txIsOut;

        var cName = "forever_itemContent";
        var toTop = 0;
        var toLeft = 0;
        var toBottom = 0;
        var toRight = 0;

        if (res.hasOwnProperty(cName)) 
        {
            toTop = res[cName].toTop;
            toLeft = res[cName].toLeft;
            toBottom = res[cName].toBottom;
            toRight = res[cName].toRight;
        }

        for (var i = 0; i < this.foreverArray.length; i++) {
            var tItem = this.foreverArray[i];
            tItem.x = res[tItem.name].x;
            tItem.y = res[tItem.name].y;
            tItem.texture = RES.getRes(res[tItem.name].background);
            tItem.visible = false;

            var txItem = this.itemTitleArray[i];
            txItem.x = tItem.x;
            txItem.y = tItem.y + txRelativeY + tItem.height;
            txItem.width = tItem.width;
            txItem.size = res[txName].fontSize;
            txItem.textColor = res["mainui"].color;
            txItem.fontFamily = res["mainui"].fontFamily;
            txItem.visible = true;
            txItem.text = "";

            var cItem = this.itemContentArray[i];
            cItem.x = tItem.x+toLeft;
            cItem.y = tItem.y+toTop;
            cItem.width = tItem.width - toLeft - toRight;
            cItem.height = tItem.height - toTop - toBottom;
            cItem.visible = false;
        }

        this.tipItem.textColor = res["mainui"].color;
        this.tipItem.fontFamily = res["mainui"].fontFamily;

        this.totalRes = res;

        this.leftBtn.visible = false;
        this.rightBtn.visible = false;

        this.totalRes = res;
        (_typeBox != 'box')?mouse.setButtonMode(this.backBtn,true):1;      
        this.iconAddMouseOverEventWithTarget(this.backBtn);
        this.iconAddMouseOutEventWithTarget(this.backBtn);
    }
    p.handleTap = function(event) {
        event.stopPropagation();
        var name = event.target.name;
        if (name == this.titlebg.name) {
            return;
        } else if (name == this.backBtn.name) {
            this.visible = false;
            this.super.AllMeunItemShowOrHide(true);
        } else if (name == this.rightBtn.name) {
            this.nextPage();
        } else if (name == this.leftBtn.name) {
            this.prePage();
        } else if (name == this.userBtn.name) {
            this.changeSwitcher(1);
        } else if (name == this.systemBtn.name) {
            this.changeSwitcher(2);
        }
        if (event.target.saveDocumentData) {
            this.content.closeMenu();
            this.content.load(event.target.saveDocumentData);
            this.visible = false;
            this.super.AllMeunItemShowOrHide(true);
            this.super.visible = false;
            this.super.super.HideUIExceptMenu(this.visible);
        };
    }
    p.nextPage = function() {
        this.content.saveDocumentPage++;
        this.pageChanged();
    }
    p.prePage = function() {
        this.content.saveDocumentPage--;
        this.pageChanged();
    }
    p.pageChanged = function() {
        var self = this;
        this.content.read({
            type: 2
        }, function(data) {
            if (data) {
                console.log(data);
                self.render(data.msg);
            };
        });
    }
    p.addBitmapItem = function(name, x, y, w, h) {
        var item = new egret.Bitmap();
        item.touchEnabled = true;
        item.texture = RES.getRes(name);
        item.name = name;
        return item;
    };
    //临时存储的时间文本
    p.addTimeItem = function(o) {
        var txItem = new egret.TextField;
        txItem.textAlign = egret.HorizontalAlign.CENTER;
        txItem.verticalAlign = egret.VerticalAlign.MIDDLE;
        txItem.type = egret.TextFieldType.DYNAMIC;
        txItem.textColor = 0xffffff;
        return txItem;
    }
    p.changeSwitcher = function(index) {
        this.content.saveDocumentPage = 1;
        if (index == 1) {
            this.toUserRead();
        } else if (index == 2) {
            this.toSystemRead();
        }
    }
    p.toUserRead = function() {
        this.userBtn.texture = RES.getRes(this.totalRes[this.userBtn.name].background_activated);
        this.systemBtn.texture = RES.getRes(this.totalRes[this.systemBtn.name].background);
        this.maxCount = 16;
        if (this.maxCount > 6) {
            this.rightBtn.visible = true;
        } else {
            this.rightBtn.visible = false;
        }
        this.pageChanged();
    }
    p.toSystemRead = function() {
        this.userBtn.texture = RES.getRes(this.totalRes[this.userBtn.name].background);
        this.systemBtn.texture = RES.getRes(this.totalRes[this.systemBtn.name].background_activated);
        this.maxCount = 11;
        if (this.maxCount > 6) {
            this.rightBtn.visible = true;
        } else {
            this.rightBtn.visible = false;
        }
        this.pageChanged();
    }

    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background);
    };

    return Forever;
}(egret.Sprite));
egret.registerClass(Forever, 'Forever');