//设置
// ly
var MenuSetting = (function(_super) {
    __extends(MenuSetting, _super);

    function MenuSetting(argvs) {
        _super.call(this);
        this.super = argvs.super;
        this.content = argvs.content;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = MenuSetting,
        p = c.prototype;
    p.onAddToStage = function() {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.touchEnabled = true;

        this.width = this.super.width;
        this.height = this.super.height;

        this.container = this.super.super.getContainer("setting");
        this.container.visible = true;
        this.addChild(this.container);
    
        this.bgArray = new Array();
        //背景
        this.contentBg = this.addBitmapItem("menuSet_contentBg");
        this.container.addChild(this.contentBg);
        this.bgArray.push(this.contentBg);

        //标题
        this.titlebg = this.addBitmapItem("menuSet_title");
        this.container.addChild(this.titlebg);
        this.bgArray.push(this.titlebg);

        this.itemPicArray = new Array();
        this.itemTitleArray = new Array();
        this.itemBgArray = new Array();
        var picArray = ["menuSet_musicBtn","menuSet_soundBtn","menuSet_voiceBtn","menuSet_animaBtn", "menuSet_downBtn"];
        var labelArray = ["menuSet_music","menuSet_sound","menuSet_voice","menuSet_anima", "menuSet_down"];
        var singleBgArray = ["menuSet_musicBg","menuSet_voiceBg","menuSet_soundBg", "menuSet_animaBg", "menuSet_downBg"];
        for (var i = 0; i < labelArray.length; i++) {
            var bgName = singleBgArray[i];
            var bgItem = this.addBitmapItem(bgName);
            this.container.addChild(bgItem);
            this.itemBgArray.push(bgItem);
            
            var picName = picArray[i];
            var picItem = this.addBitmapItem(picName);
            picItem.tag = i;
            this.container.addChild(picItem);
            this.itemPicArray.push(picItem);
            var labelName = labelArray[i];
            var labelItem = this.addBitmapItem(labelName);
            labelItem.text = labelArray[i];
            this.container.addChild(labelItem);
            this.itemTitleArray.push(labelItem);
        }
        //返回按钮
        this.backBtn = this.addBitmapItem("menuSet_back");
        this.addChild(this.backBtn);
        this.bgArray.push(this.backBtn);
    }
    p.setSkin = function(skinname, res) {
        for (var i = 0; i < this.bgArray.length; i++) {
            var item = this.bgArray[i];
            item.texture = RES.getRes(res[item.name].background);
            item.x = res[item.name].x;
            item.y = res[item.name].y;
        }

        var backBtnPs = ["## $sw - "+this.backBtn.x,this.backBtn.y,null,null,"## $w",0];
        this.super.super.positonParameters(this.backBtn,backBtnPs);

        for (var i = 0; i < this.itemPicArray.length; i++) {
            var titleItem = this.itemTitleArray[i];
            var txName = titleItem.name;

            if (res.hasOwnProperty(txName)) 
            {
                titleItem.x = res[txName].x;
                titleItem.y = res[txName].y;
                titleItem.texture = RES.getRes(res[txName].background);
            }
           
            var item = this.itemPicArray[i];
            var itemName = item.name;

            if (res.hasOwnProperty(itemName)) 
            {         
                item.texture = RES.getRes(res[itemName].background);
                item.x = res[itemName].x;
                item.y = res[itemName].y;
            }

            var bg = this.itemBgArray[i];
            var bgName = bg.name;

            if (res.hasOwnProperty(bgName)) 
            {
                bg.texture = RES.getRes(res[bgName].background);
                bg.x = res[bgName].x;
                bg.y = res[bgName].y;
            }
        }
        this.skinname = skinname;
        this.res = res;
        this.isMusicOn = true;
        this.isAnimaOn = true;

        this.totalRes = res;
        // mouse.setButtonMode(this.backBtn,true);
         (_typeBox != 'box')?mouse.setButtonMode(this.backBtn,true):1;
        this.iconAddMouseOverEventWithTarget(this.backBtn);
        this.iconAddMouseOutEventWithTarget(this.backBtn);
    }
    p.handleTap = function(event) {
        var name = event.target.name;
        var tag = event.target.tag;
        event.stopPropagation();
        var name = event.target.name;
        if (name == this.backBtn.name) {
            this.visible = false;
            this.super.AllMeunItemShowOrHide(true);
        } else if (tag == this.itemPicArray[4].tag) {
            //下载按钮点击
            if (egret.Capabilities.os === "Windows PC") {
                window.open(Config.pc_vortexBoxUrl);
            } else if (egret.Capabilities.os === "Android") {
                window.open(Config.pc_vortexBoxUrl);
            } else if (egret.Capabilities.os === "iOS") {
                window.open(Config.ios_vortexBoxUrl);
            };
        } else if (tag == this.itemPicArray[0].tag) {
            var resOff = "OffButton";
            var resOn = "OnButton";
            var picItem = this.itemPicArray[0];
            if (this.content.musicSwitch) {
                picItem.texture = RES.getRes(resOff);
                this.content.musicSwitch = false;
                this.content.offMusic();
            } else {
                picItem.texture = RES.getRes(resOn);
                this.content.musicSwitch = true;
                this.content.onMusic();
            }
        }else if (tag == this.itemPicArray[1].tag)
        {
            //语音
            var resOff = "OffButton";
            var resOn = "OnButton";
            var picItem = this.itemPicArray[1];
            if (this.content.soundSwitch) {
                picItem.texture = RES.getRes(resOff);
                this.content.soundSwitch = false;
                this.content.offSound(1);
            } else {
                picItem.texture = RES.getRes(resOn);
                this.content.soundSwitch = true;
                this.content.onSound(1);
            }

        } else if (tag == this.itemPicArray[2].tag)
        {
            //音效
            var resOff = "OffButton";
            var resOn = "OnButton";
            var picItem = this.itemPicArray[2];
            if (this.content.voiceSwitch) {
                picItem.texture = RES.getRes(resOff);
                this.content.voiceSwitch = false;
                this.content.offSound(2);
            } else {
                picItem.texture = RES.getRes(resOn);
                this.content.voiceSwitch = true;
                this.content.onSound(2);
            }

        }else if (tag == this.itemPicArray[3].tag) {
            var resOff = "OffButton";
            var resOn = "OnButton";
            var picItem = this.itemPicArray[3];
            if (this.content.animSwitch) {
                picItem.texture = RES.getRes(resOff);
                this.content.animSwitch = false;
                this.content.vortexEffect();
                // this.content.animStop();
            } else {
                picItem.texture = RES.getRes(resOn);
                this.content.animSwitch = true;
            }
        }
    }
    p.addBitmapItem = function(name) {
        var item = new egret.Bitmap();
        item.touchEnabled = true;
        item.name = name;
        return item;
    }

    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background);
    };

    return MenuSetting;
}(egret.Sprite));
egret.registerClass(MenuSetting, 'MenuSetting');