//share.js
//分享页面
// ly
var UIShare = (function(_super) {
    __extends(UIShare, _super);

    function UIShare(argvs) {
        _super.call(this);
        this.content = argvs.content;
        this.super = argvs.super;
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
    }
    var d = __define,
        c = UIShare,
        p = c.prototype;
    p.onAddToStage = function() {
        this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.handleTap, this);
        this.touchEnabled = true;
        this.container = this.super.super.getContainer("share_layout");
        this.container.visible = true;
        this.addChild(this.container);
        this.itemBgArray = new Array();
        this.contentBg = this.addBitmapItem("UIShare_contentBg");
        this.container.addChild(this.contentBg);
        this.itemBgArray.push(this.contentBg);
        //标题
        // this.titlebg = this.addBitmapItem("UIShare_title");
        // this.addChild(this.titlebg);
        // this.itemBgArray.push(this.titlebg);
        var hideTip = IsPC();
        this.shareTip = this.addBitmapItem("shareTip");
        this.shareTip.visible = !hideTip;
        this.addChild(this.shareTip);
        this.shareNameArray = ["UIShare_QQ", "UIShare_wechat", "UIShare_weibo"];
        for (var i = 0; i < this.shareNameArray.length; i++) {
            var itemName = this.shareNameArray[i];
            var itemBg = this.addBitmapItem(itemName);
            itemBg.tag = i;
            this.container.addChild(itemBg);
            this.itemBgArray.push(itemBg);
        }
        this.container.visible = hideTip;
        //返回按钮
        this.backBtn = this.addBitmapItem("UIShare_back");
        this.addChild(this.backBtn);
        this.itemBgArray.push(this.backBtn);
    }
    p.setSkin = function(skinname, res) {
        this.shareTip.texture = RES.getRes(this.shareTip.name);
        this.shareTip.x = (this.width - this.shareTip.width) / 2.0;
        this.shareTip.y = (this.height - this.shareTip.height) / 2.0;
        for (var i = 0; i < this.itemBgArray.length; i++) {
            var item = this.itemBgArray[i];
            item.texture = RES.getRes(res[item.name].background);
            item.x = res[item.name].x;
            item.y = res[item.name].y;
        }
        var backBtnPs = ["## $sw - " + this.backBtn.x, this.backBtn.y, null, null, "## $w", 0];
        this.super.super.positonParameters(this.backBtn, backBtnPs);
        this.totalRes = res;
        // mouse.setButtonMode(this.backBtn, true);
         (_typeBox != 'box')?mouse.setButtonMode(this.backBtn, true):1;
        this.iconAddMouseOverEventWithTarget(this.backBtn);
        this.iconAddMouseOutEventWithTarget(this.backBtn);
    }

    function sprintf(urlBase) {
        for (var i in arguments) {
            if (i > 0) {
                urlBase = urlBase.replace("%s", arguments[i]);
            };
        }
        return urlBase;
    }
    p.handleTap = function(event) {
        event.stopPropagation();
        var name = event.target.name;
        if (name == this.backBtn.name) {
            this.visible = false;
            this.super.AllMeunItemShowOrHide(true);
        } else {
            var shareTextList = [];
            shareTextList.push('偷偷告诉你一个秘密，最近我在玩漩涡互娱的【%s】根本停不下来！');
            shareTextList.push('小伙伴们，想知道我最近在玩什么吗？推荐一款【%s】的漩涡作品来和我一起寻宝吧！');
            shareTextList.push('嗨艾瑞巴蒂，分享给你一款超级好玩的漩涡作品【%s】一般人我才不告诉他！');
            shareTextList.push('爱妃们，本王最近玩了一款【%s】的漩涡作品，满满的剧情特效让本王欲罢不能啊！');
            shareTextList.push('本宝宝最近在玩一款【%s】的漩涡作品，同样爱玩游戏的你怎么能错过呢！');
            shareTextList.push('糟糕被发现了，分享我的私藏作品【%s】给你玩吧~');
            shareTextList.push('嘿！分享给你的漩涡红包——【%s】');
            shareTextList.push('玩过这个【%s】我已经不知道节操是什么了！');
            var urlQzone = 'http://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?url=%s&title=%s&summary=%s',
                urlWeibo = 'http://service.weibo.com/share/share.php?url=%s&title=%s';
            var shareText = shareTextList[Math.floor(Math.random() * shareTextList.length + 1) - 1],
                urlBase = window.location.href.split('&')[0],
                gameName = this.content.vt.script.global.name,
                cover = this.content.vt.script.global.convent,
                urlPic = cover ? (this.content.resurl + "resource.jpeg?fs=" + cover) : (Config.material + "resource.jpeg?fs=/cover/20161122/fde1aa216fea46eea71470547b57ad48.jpg");
            // 构造分享内容
            urlBase = urlBase + '&type=share';
            shareText = sprintf(shareText, gameName);
            if (name == this.shareNameArray[0]) {
                //QQ分享
                this.content.net.log({
                    type: 0,
                    way: 1
                });
                urlBase = sprintf(urlQzone, encodeURIComponent(urlBase), gameName, shareText);
                if (urlPic) urlBase += '&pics=' + urlPic;
                window.open(urlBase);
            } else if (name == this.shareNameArray[1]) {
                //微信分享
            } else if (name == this.shareNameArray[2]) {
                //新浪分享
                this.content.net.log({
                    type: 0,
                    way: 2
                });
                urlBase = sprintf(urlWeibo, encodeURIComponent(urlBase), shareText);
                if (urlPic) urlBase += '&pic=' + urlPic;
                window.open(urlBase);
            }
        }
    }
    p.addBitmapItem = function(name) {
        var item = new egret.Bitmap();
        item.touchEnabled = true;
        item.name = name;
        (_typeBox != 'box')?mouse.setButtonMode(item, true):1;
        return item;
    }
    p.iconAddMouseOverEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OVER, this.iconMoveOver, this);
    };
    p.iconAddMouseOutEventWithTarget = function(target) {
        if (_typeBox == 'box') {
                return;
            }
        target.addEventListener(mouse.MouseEvent.MOUSE_OUT, this.iconMoveOut, this);
    };
    p.iconMoveOver = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background_activated);
    };
    p.iconMoveOut = function(event) {
        var name = event.target.name;
        var res = this.totalRes;
        event.target.texture = RES.getRes(res[name].background);
    };
    return UIShare;
}(egret.Sprite));
egret.registerClass(UIShare, 'UIShare');